@IsTest
public with sharing class TestScenarioAlignmentCtlr {
static{
        list<Alignment_Global_Settings__c> allAlignmentGlobalSetting = new list<Alignment_Global_Settings__c>();
        Alignment_Global_Settings__c alignmentSetting  = new Alignment_Global_Settings__c();
        alignmentSetting.Name = 'TeamCodeMax';
        alignmentSetting.Tree_Hierarchy_Sort_Field__c = '1';
        allAlignmentGlobalSetting.add(alignmentSetting);

        Alignment_Global_Settings__c alignmentSetting1  = new Alignment_Global_Settings__c();
        alignmentSetting1.Name = 'TeamInstanceCodeMax';
        alignmentSetting1.Tree_Hierarchy_Sort_Field__c = '1';
        //insert alignmentSetting1;
        allAlignmentGlobalSetting.add(alignmentSetting1);


        Alignment_Global_Settings__c alignmentsettingMapAccountClusterFlag  = new Alignment_Global_Settings__c();
        alignmentsettingMapAccountClusterFlag.Name = 'MapAccountClusterFlag';
        alignmentsettingMapAccountClusterFlag.Tree_Hierarchy_Sort_Field__c = 'true';
        //insert alignmentsettingMapAccountClusterFlag;
        allAlignmentGlobalSetting.add(alignmentsettingMapAccountClusterFlag);

        Alignment_Global_Settings__c alignmentsettingThresholdValue  = new Alignment_Global_Settings__c();
        alignmentsettingThresholdValue.Name = 'MapAccountThresholdValue';
        alignmentsettingThresholdValue.Tree_Hierarchy_Sort_Field__c = '1000';
        //insert alignmentsettingThresholdValue;
        allAlignmentGlobalSetting.add(alignmentsettingThresholdValue);

        Alignment_Global_Settings__c alignmentsettingDateFormat  = new Alignment_Global_Settings__c();
        alignmentsettingDateFormat.Name = 'DateFormat';
        alignmentsettingDateFormat.Tree_Hierarchy_Sort_Field__c = 'mm/dd/yyyy';
        //insert alignmentsettingDateFormat;
        allAlignmentGlobalSetting.add(alignmentsettingDateFormat);

        
        Alignment_Global_Settings__c alignmentsettingnotificationTimeOut  = new Alignment_Global_Settings__c();
        alignmentsettingnotificationTimeOut.Name = 'notificationTimeOut';
        alignmentsettingnotificationTimeOut.Tree_Hierarchy_Sort_Field__c = '10000';        
        allAlignmentGlobalSetting.add(alignmentsettingnotificationTimeOut);

        Alignment_Global_Settings__c alignmentsettingPrintLimit  = new Alignment_Global_Settings__c();
        alignmentsettingPrintLimit.Name = 'MapPrintRequestLimit';
        alignmentsettingPrintLimit.Tree_Hierarchy_Sort_Field__c = '3';
        allAlignmentGlobalSetting.add(alignmentsettingPrintLimit);
        
        Alignment_Global_Settings__c alignmentsettinMaxAccountLassoLimit  = new Alignment_Global_Settings__c();
        alignmentsettinMaxAccountLassoLimit.Name = 'MaxAccsSelectionLimit';
        alignmentsettinMaxAccountLassoLimit.Tree_Hierarchy_Sort_Field__c = '50';
        allAlignmentGlobalSetting.add(alignmentsettinMaxAccountLassoLimit);

        Alignment_Global_Settings__c alignmentsettingMaximumAccountsForAffiliation  = new Alignment_Global_Settings__c();
        alignmentsettingMaximumAccountsForAffiliation.Name = 'MaximumAccountsForAffiliation';
        alignmentsettingMaximumAccountsForAffiliation.Tree_Hierarchy_Sort_Field__c = '100';
        allAlignmentGlobalSetting.add(alignmentsettingMaximumAccountsForAffiliation);

        Alignment_Global_Settings__c alignmentsettingShowSelectAllTerritory  = new Alignment_Global_Settings__c();
        alignmentsettingShowSelectAllTerritory.Name = 'ShowSelectAllTerritory';
        alignmentsettingShowSelectAllTerritory.Tree_Hierarchy_Sort_Field__c = 'true';
        allAlignmentGlobalSetting.add(alignmentsettingShowSelectAllTerritory);

        Alignment_Global_Settings__c alignmentsettingBulkSearchInputLimit  = new Alignment_Global_Settings__c();
        alignmentsettingBulkSearchInputLimit.Name = 'BulkSearchInputLimit';
        alignmentsettingBulkSearchInputLimit.Tree_Hierarchy_Sort_Field__c = '10';
        allAlignmentGlobalSetting.add(alignmentsettingBulkSearchInputLimit);

        Alignment_Global_Settings__c alignmentsettingMaxZIPsSelectionLimit  = new Alignment_Global_Settings__c();
        alignmentsettingMaxZIPsSelectionLimit.Name = 'MaxZIPsSelectionLimit';
        alignmentsettingMaxZIPsSelectionLimit.Tree_Hierarchy_Sort_Field__c = '10';
        allAlignmentGlobalSetting.add(alignmentsettingMaxZIPsSelectionLimit);
        
        insert allAlignmentGlobalSetting;

        TriggerContol__c setSecurityUtil = new TriggerContol__c();
        setSecurityUtil.Name = 'SecurityUtil';
        setSecurityUtil.IsStopTrigger__c =  true;
        insert setSecurityUtil;

      }
      
      static testMethod void testZIPAlignment(){
        //Creating custom setting test data
        ReadOnlyApplication__c setting  = new ReadOnlyApplication__c();
        setting.Alignment__c = false;
        setting.Secondary_Assignment_Alignment__c = true;
        insert setting;
        
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;
        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;
        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;
        
         list<DiplayColorCriteria__c> colorSettings = new list<DiplayColorCriteria__c>();
        colorSettings.add(new DiplayColorCriteria__c(Name='Error',Color__c='#F8CBAD'));
        colorSettings.add(new DiplayColorCriteria__c(Name='Normal',Color__c='#FFFFFF'));
        colorSettings.add(new DiplayColorCriteria__c(Name='Warning',Color__c='#ffE699'));
        insert colorSettings;
        
        Team__c baseTeam = new Team__c(Name='HTN',Type__c='Base',Effective_End_Date__c=Date.today().addMonths(50),Country__c=country.id);
        insert baseTeam;
        
        Team__c overlayTeam = new Team__c(Name='HTN Overlay',Type__c='Overlay',Controlling_Team__c= baseTeam.id,Country__c=country.id);
        insert overlayTeam;
        
        Workspace__c wrk = new Workspace__c();
        wrk.Workspace_Start_Date__c = Date.Today();
        wrk.Workspace_End_Date__c  = Date.today().addMonths(50);
        wrk.Name = 'Workspace 1';
        wrk.Workspace_Description__c = 'New Workspace';
        wrk.Country__c=country.id;
        insert wrk;
        
        
        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = false;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrk.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;
        scenario.Scenario_Stage__c =    SalesIQGlobalConstants.COLLABORATION;    
        scenario.Scenario_Type__c = SalesIQGlobalConstants.SCENARIO_TYPE_ALIGNMENT;
        scenario.Scenario_Status__c = SalesIQGlobalConstants.SCENARIO_STATUS_ACTIVE;
        insert scenario;

        Business_Rule_Type_Master__c brtm = new Business_Rule_Type_Master__c();
        brtm.name = 'Assignment Rules';
        insert brtm;

        Team_Instance__c BaseTeamInstance = new Team_Instance__c();
        BaseTeamInstance.Name = 'HTN_Q1_2016';
        BaseTeamInstance.Alignment_Period__c = 'Current';
        BaseTeamInstance.Team__c = baseTeam.id;
        BaseTeamInstance.Alignment_Type__c = 'ZIP';
        BaseTeamInstance.isActiveCycle__c = 'Y';  
        BaseTeamInstance.Team_Cycle_Name__c = 'Current';
        BaseTeamInstance.Scenario__c  = scenario.id;  
        BaseTeamInstance.Team_Instance_Code__c = 'DI-00001'; 
        BaseTeamInstance.IC_EffstartDate__c = Date.today().addMonths(-1);
        BaseTeamInstance.IC_EffEndDate__c = Date.today().addYears(1);       
        BaseTeamInstance.Show_Custom_Metric__c=true;
        BaseTeamInstance.Geography_Type_Name__c = geotype.id;
        BaseTeamInstance.doContiguityCheck__c = true;
        BaseTeamInstance.doDoughnutCheck__c = true;
        BaseTeamInstance.CIM_available__c = true;

        insert BaseTeamInstance;
        
        Team_Instance__c OverlayTeamInstance = new Team_Instance__c();
        OverlayTeamInstance.Name = 'Overlay HTN 2016';
        OverlayTeamInstance.Alignment_Period__c = 'Current';
        OverlayTeamInstance.Team__c = overlayTeam.id;
        OverlayTeamInstance.Alignment_Type__c = 'ZIP';
        OverlayTeamInstance.isActiveCycle__c = 'Y'; 
        OverlayTeamInstance.Team_Instance_Code__c = 'DI-00002';
        OverlayTeamInstance.IC_EffstartDate__c = Date.today().addMonths(-1);
        OverlayTeamInstance.IC_EffEndDate__c = Date.today().addYears(1);  
        insert OverlayTeamInstance;
        
                
        Position__c nation = new Position__c();
        nation.name = 'USA';
        nation.Client_Territory_Name__c = 'North east';
        nation.Client_Position_Code__c = '1NE30000';
        nation.Client_Territory_Code__c='1NE30000';
        nation.Position_Type__c='Nation';
        nation.inactive__c = false;
        nation.RGB__c = '41,210,117';
        nation.Team_iD__c = baseTeam.id;
        nation.Hierarchy_Level__c='4';
        nation.Related_Position_Type__c  ='Base';
        nation.Effective_End_Date__c=Date.today().addMonths(50);
        nation.Team_Instance__c = BaseTeamInstance.id;
        nation.Position_Category__c = 'Field Position';
        insert nation;
        
        Position__c region = new Position__c();
        region.name = 'North east';
        region.Client_Territory_Name__c = 'North east';
        region.Client_Position_Code__c = '1NE30000';
        region.Client_Territory_Code__c='1NE30000';
        region.Position_Type__c='Region';
        region.inactive__c = false;
        region.RGB__c = '41,210,117';
        region.Team_iD__c = baseTeam.id;
        region.Effective_End_Date__c=Date.today().addMonths(50);
        region.Hierarchy_Level__c = '3';
        region.Related_Position_Type__c  ='Base';
        region.Team_Instance__c = BaseTeamInstance.id;
        region.Position_Category__c = 'Field Position';
        insert region;
        
        Position_Team_Instance__c regionTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(region, null, BaseTeamInstance);
        regionTeamInstance.X_Max__c=-72.6966429900;
        regionTeamInstance.X_Min__c=-73.9625820000;
        regionTeamInstance.Y_Max__c=40.9666490000;
        regionTeamInstance.Y_Min__c=40.5821279800;
        insert regionTeamInstance;
        
        Position__c district = new Position__c();
        district.name = 'Newyork';
        district.Client_Territory_Name__c = 'Newyork';
        district.Client_Position_Code__c = '1NE30001';
        district.Client_Territory_Code__c='1NE30001';
        district.Position_Type__c='District';
        district.inactive__c = false;
        district.RGB__c = '41,210,117';
        district.Team_iD__c = baseTeam.id;
        district.Parent_Position__c = region.Id;
        district.Hierarchy_Level__c='2';
        district.Related_Position_Type__c  ='Base';
        district.Effective_End_Date__c=Date.today().addMonths(50);
        district.Team_Instance__c = BaseTeamInstance.id;
        district.Position_Category__c = 'Field Position';
        insert district;
        
        Position_Team_Instance__c districtTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(district, region, BaseTeamInstance);
        districtTeamInstance.X_Max__c=-72.6966429900;
        districtTeamInstance.X_Min__c=-73.9625820000;
        districtTeamInstance.Y_Max__c=40.9666490000;
        districtTeamInstance.Y_Min__c=40.5821279800;
        insert districtTeamInstance;
        
        Position__c territory = new Position__c();
        territory.name = 'Long Island East';
        territory.Client_Territory_Name__c = 'Long Island East';
        territory.Client_Position_Code__c = '1NE30011';
        territory.Client_Territory_Code__c='1NE30011';
        territory.Position_Type__c='Territory';
        territory.inactive__c = false;
        territory.RGB__c = '41,210,117';
        territory.Team_iD__c = baseTeam.id;
        territory.Parent_Position__c = district.Id; 
        territory.Effective_Start_Date__c=Date.today();       
        territory.Effective_End_Date__c=Date.today().addMonths(50);
        territory.Related_Position_Type__c = 'Base';
        territory.Hierarchy_Level__c = '1'; 
        territory.Team_Instance__c =  BaseTeamInstance.id;
        territory.Position_Category__c = 'Field Position';
        insert territory;
        
        Position__c OverlaySourceterritory = new Position__c();
        OverlaySourceterritory.name = 'Long Island East';
        OverlaySourceterritory.Client_Territory_Name__c = 'Long Island East';
        OverlaySourceterritory.Client_Position_Code__c = '1NE30011';
        OverlaySourceterritory.Client_Territory_Code__c='1NE30011';
        OverlaySourceterritory.Position_Type__c='Territory';
        OverlaySourceterritory.inactive__c = false;
        OverlaySourceterritory.RGB__c = '41,210,117';
        OverlaySourceterritory.Team_iD__c = overlayTeam.id;
        OverlaySourceterritory.Parent_Position__c = district.Id;
        OverlaySourceterritory.Effective_End_Date__c=Date.today().addMonths(50);
        OverlaySourceterritory.Related_Position_Type__c = 'Overlay';
        OverlaySourceterritory.Hierarchy_Level__c = '1';
        OverlaySourceterritory.Position_Category__c = 'Field Position';
        insert OverlaySourceterritory;
        
        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, district, BaseTeamInstance);
        territoryTeamInstance.X_Max__c=-72.6966429900;
        territoryTeamInstance.X_Min__c=-73.9625820000;
        territoryTeamInstance.Y_Max__c=40.9666490000;
        territoryTeamInstance.Y_Min__c=40.5821279800;
        insert territoryTeamInstance;
        
        Position_Team_Instance__c OverlaySourceTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(OverlaySourceterritory, district, OverlayTeamInstance);
        OverlaySourceTeamInstance.X_Max__c=-72.6966429900;
        OverlaySourceTeamInstance.X_Min__c=-73.9625820000;
        OverlaySourceTeamInstance.Y_Max__c=40.9666490000;
        OverlaySourceTeamInstance.Y_Min__c=40.5821279800;
        insert OverlaySourceTeamInstance;
        
        Position__c destTerr = new Position__c();
        destTerr.Name = 'Long Island West';
        destTerr.Client_Territory_Name__c = 'Long Island West';
        destTerr.Client_Position_Code__c = '1NE30012';
        destTerr.Client_Territory_Code__c='1NE30012';
        destTerr.Position_Type__c='Territory';
        destTerr.inactive__c = false;
        destTerr.RGB__c = '41,210,117';
        destTerr.Team_iD__c = baseTeam.id;
        destTerr.Parent_Position__c = district.Id;
        destTerr.Hierarchy_Level__c = '1';
        destTerr.Related_Position_Type__c  ='Base';
        destTerr.Effective_End_Date__c=Date.today().addMonths(50);
        destTerr.Team_Instance__c = BaseTeamInstance.id;
        destTerr.Position_Category__c = 'Field Position';
        insert destTerr;
        
        Position__c OverlaydestTerr = new Position__c();
        OverlaydestTerr.Name = 'Long Island West';
        OverlaydestTerr.Client_Territory_Name__c = 'Long Island West';
        OverlaydestTerr.Client_Position_Code__c = '1NE30012';
        OverlaydestTerr.Client_Territory_Code__c='1NE30012';
        OverlaydestTerr.Position_Type__c='Territory';
        OverlaydestTerr.inactive__c = false;
        OverlaydestTerr.RGB__c = '41,210,117';
        OverlaydestTerr.Team_iD__c = overlayTeam.id;
        OverlaydestTerr.Parent_Position__c = district.Id;
        OverlaydestTerr.Hierarchy_Level__c = '1';
        OverlaydestTerr.Related_Position_Type__c  ='Overlay';
        OverlaydestTerr.Effective_End_Date__c=Date.today().addMonths(50);
        OverlaydestTerr.Position_Category__c = 'Field Position';
        insert OverlaydestTerr;
        
        Position_Team_Instance__c destTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerr, district, BaseTeamInstance);
        destTerrTeamInstance.X_Max__c=-72.6966429900;
        destTerrTeamInstance.X_Min__c=-73.9625820000;
        destTerrTeamInstance.Y_Max__c=40.9666490000;
        destTerrTeamInstance.Y_Min__c=40.5821279800;
        insert destTerrTeamInstance;
        
        Position_Team_Instance__c OverlaydestTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(OverlaydestTerr, district, OverlayTeamInstance);
        OverlaydestTerrTeamInstance.X_Max__c=-72.6966429900;
        OverlaydestTerrTeamInstance.X_Min__c=-73.9625820000;
        OverlaydestTerrTeamInstance.Y_Max__c=40.9666490000;
        OverlaydestTerrTeamInstance.Y_Min__c=40.5821279800;
        insert OverlaydestTerrTeamInstance;
        
        User_Access_Permission__c access = new User_Access_Permission__c();
        access.Position__c = region.id;
        access.Map_Access_Position__c = region.id;
        access.name='access';
        access.Team_Instance__c = BaseTeamInstance.id;   
        access.User__c = UserInfo.getUserId();
        access.Is_Active__c = true;
        insert access;
        
        User_Access_Permission__c Overlayaccess = new User_Access_Permission__c();
        Overlayaccess.Position__c = region.id;
        Overlayaccess.Map_Access_Position__c = region.id;
        Overlayaccess.name='Overlayaccess';
        Overlayaccess.Team_Instance__c = OverlayTeamInstance.id;   
        Overlayaccess.User__c = UserInfo.getUserId();
        Overlayaccess.Is_Active__c = true;
        insert Overlayaccess;
        
        Geography__c geo1 = new Geography__c();
        geo1.Name = '11788';
        geo1.City__c='Test 11788';
        geo1.State__c = '11788';
        geo1.Neighbor_Geography__c = '11789';
        geo1.Zip_Type__c = 'Standard';
        geo1.Centroid_Latitude__c = 0.0;
        geo1.Centroid_Longitude__c = 0.0;
        geo1.External_Country_Id__c=country.id;
        geo1.External_Geo_Type__c= geotype.id;
        geo1.Geography_Type__c= geotype.id;
        insert geo1; 

        
        
        Position_Geography__c posGeo1  = new Position_Geography__c();
        posGeo1.Effective_Start_Date__c  = Date.today().addMonths(-1);
        posGeo1.Effective_End_Date__c  = Date.today().addYears(1);
        posGeo1.Geography__c = geo1.id;     
        posGeo1.Position__c = territory.id;
        posGeo1.Team_Instance__c = BaseTeamInstance.id ;
        posGeo1.Position_Team_Instance__c = territoryTeamInstance.id;
        posGeo1.Change_Status__c = 'No Change';
        posGeo1.Metric1__c  =2.010000000000;
        posGeo1.Metric2__c  =29.000000000000;
        posGeo1.Metric3__c  =2.000000000000;
        posGeo1.Metric4__c  =1.431479545000;
        posGeo1.Metric5__c  =1.490000000000;
        posGeo1.Metric6__c  =2.010000000000;
        posGeo1.Metric7__c  =29.000000000000;
        posGeo1.Metric8__c  =2.000000000000;
        posGeo1.Metric9__c  =1.431479545000;
        posGeo1.Metric10__c =1.490000000000;
        insert posGeo1;
        
        Position_Geography__c OverlayPositionGeoSource  = new Position_Geography__c();
        OverlayPositionGeoSource.Effective_Start_Date__c  = Date.today().addMonths(-1);
        OverlayPositionGeoSource.Effective_End_Date__c  = Date.today().addYears(1);
        OverlayPositionGeoSource.Geography__c = geo1.id;
        OverlayPositionGeoSource.Position__c = OverlaySourceterritory.id;
        OverlayPositionGeoSource.Team_Instance__c = OverlayTeamInstance.id ;
        OverlayPositionGeoSource.Position_Team_Instance__c = OverlaySourceTeamInstance.id;
        OverlayPositionGeoSource.Change_Status__c = 'No Change';
        OverlayPositionGeoSource.Metric1__c  =2.010000000000;
        OverlayPositionGeoSource.Metric2__c  =29.000000000000;
        OverlayPositionGeoSource.Metric3__c  =2.000000000000;
        OverlayPositionGeoSource.Metric4__c  =1.431479545000;
        OverlayPositionGeoSource.Metric5__c  =1.490000000000;
        OverlayPositionGeoSource.Metric6__c  =2.010000000000;
        OverlayPositionGeoSource.Metric7__c  =29.000000000000;
        OverlayPositionGeoSource.Metric8__c  =2.000000000000;
        OverlayPositionGeoSource.Metric9__c  =1.431479545000;
        OverlayPositionGeoSource.Metric10__c =1.490000000000;
        insert OverlayPositionGeoSource;
        
        Business_Rules__c br =  new Business_Rules__c();
        br.Rule_Level__c = 'Position'; 
        br.Scenario__c = scenario.Id;
        br.Selected_Positions__c = territory.Id;
        br.Business_Rule_Type_Master__c = brtm.id;
        insert br;
        
        
        Geography__c geo2 = new Geography__c();
        geo2.Name = '11789';
        geo2.City__c='Test 11789';
        geo2.State__c = '11789';
        //geo2.Neighbor_Geography__c = '11788';
        geo2.Centroid_Latitude__c = 0.0;
        geo2.Centroid_Longitude__c = 0.0;
        geo2.Zip_Type__c = 'Point';
        geo2.Parent_Zip_Code__c = geo1.Id;
        geo2.External_Country_Id__c=country.id;
        geo2.External_Geo_Type__c= geotype.id;
        geo2.Geography_Type__c= geotype.id;
        insert geo2; 
        
        /*Team_Instance_Geography__c teamInsGeo2 = new Team_Instance_Geography__c();
        teamInsGeo2.Geography__c = geo2.id;
        teamInsGeo2.Team_Instance__c = BaseTeamInstance.id;
        teamInsGeo2.Effective_Start_Date__c = Date.today().addMonths(-1);
        teamInsGeo2.Effective_End_Date__c = Date.today().addYears(1);
        teamInsGeo2.Metric1__c  =2.010000000000;
        teamInsGeo2.Metric2__c  =29.000000000000;
        teamInsGeo2.Metric3__c  =2.000000000000;
        teamInsGeo2.Metric4__c  =1.431479545000;
        teamInsGeo2.Metric5__c  =1.490000000000;
        teamInsGeo2.Metric6__c  =2.010000000000;
        teamInsGeo2.Metric7__c  =29.000000000000;
        teamInsGeo2.Metric8__c  =2.000000000000;
        teamInsGeo2.Metric9__c  =1.431479545000;
        teamInsGeo2.Metric10__c =1.490000000000;
        insert teamInsGeo2;*/
        
        /*Team_Instance_Geography__c OverlayteamInsGeo2 = new Team_Instance_Geography__c();
        OverlayteamInsGeo2.Geography__c = geo2.id;
        OverlayteamInsGeo2.Team_Instance__c = OverlayTeamInstance.id;
        OverlayteamInsGeo2.Effective_Start_Date__c = Date.today().addMonths(-1);
        OverlayteamInsGeo2.Effective_End_Date__c = Date.today().addYears(1);
        OverlayteamInsGeo2.Metric1__c  =2.010000000000;
        OverlayteamInsGeo2.Metric2__c  =29.000000000000;
        OverlayteamInsGeo2.Metric3__c  =2.000000000000;
        OverlayteamInsGeo2.Metric4__c  =1.431479545000;
        OverlayteamInsGeo2.Metric5__c  =1.490000000000;
        OverlayteamInsGeo2.Metric6__c  =2.010000000000;
        OverlayteamInsGeo2.Metric7__c  =29.000000000000;
        OverlayteamInsGeo2.Metric8__c  =2.000000000000;
        OverlayteamInsGeo2.Metric9__c  =1.431479545000;
        OverlayteamInsGeo2.Metric10__c =1.490000000000;
        insert OverlayteamInsGeo2;*/
        
        Position_Geography__c posGeo2  = new Position_Geography__c();
        posGeo2.Effective_Start_Date__c  = Date.today().addMonths(-1);
        posGeo2.Effective_End_Date__c  = Date.today().addYears(1);
        posGeo2.Geography__c = geo2.id;
        posGeo2.Position__c = territory.id;
        posGeo2.Team_Instance__c = BaseTeamInstance.id ;
        //posGeo2.Team_Instance_Geography__c = teamInsGeo2.id;
        posGeo2.Position_Team_Instance__c = territoryTeamInstance.id;
        posGeo2.Change_Status__c = 'No Change';
        posGeo2.Metric1__c  =2.010000000000;
        posGeo2.Metric2__c  =29.000000000000;
        posGeo2.Metric3__c  =2.000000000000;
        posGeo2.Metric4__c  =1.431479545000;
        posGeo2.Metric5__c  =1.490000000000;
        posGeo2.Metric6__c  =2.010000000000;
        posGeo2.Metric7__c  =29.000000000000;
        posGeo2.Metric8__c  =2.000000000000;
        posGeo2.Metric9__c  =1.431479545000;
        posGeo2.Metric10__c =1.490000000000;
        insert posGeo2;
        
        Position_Geography__c OverlayDestinationposGeo2  = new Position_Geography__c();
        OverlayDestinationposGeo2.Effective_Start_Date__c  = Date.today().addMonths(-1);
        OverlayDestinationposGeo2.Effective_End_Date__c  = Date.today().addYears(1);
        OverlayDestinationposGeo2.Geography__c = geo2.id;
        OverlayDestinationposGeo2.Position__c = OverlaydestTerr.id;
        OverlayDestinationposGeo2.Team_Instance__c = OverlayTeamInstance.id ;
        //OverlayDestinationposGeo2.Team_Instance_Geography__c = OverlayteamInsGeo2.id;
        OverlayDestinationposGeo2.Position_Team_Instance__c = OverlaydestTerrTeamInstance.id;
        OverlayDestinationposGeo2.Change_Status__c = 'No Change';
        OverlayDestinationposGeo2.Metric1__c  =2.010000000000;
        OverlayDestinationposGeo2.Metric2__c  =29.000000000000;
        OverlayDestinationposGeo2.Metric3__c  =2.000000000000;
        OverlayDestinationposGeo2.Metric4__c  =1.431479545000;
        OverlayDestinationposGeo2.Metric5__c  =1.490000000000;
        OverlayDestinationposGeo2.Metric6__c  =2.010000000000;
        OverlayDestinationposGeo2.Metric7__c  =29.000000000000;
        OverlayDestinationposGeo2.Metric8__c  =2.000000000000;
        OverlayDestinationposGeo2.Metric9__c  =1.431479545000;
        OverlayDestinationposGeo2.Metric10__c =1.490000000000;
        insert OverlayDestinationposGeo2;
        
        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'Physician';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c = country.id;
        insert acc;
        
        /*Team_Instance_Account__c teamInstanceAcc = CallPlanTestDataFactory.createTeamInstanceAccount(acc,BaseTeamInstance);
        insert teamInstanceAcc;
        */
        Position_Account__c posAcc = CallPlanTestDataFactory.createPositionAccount(acc, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc;
                
        Account acc1 = new Account();
        acc1.Name = '11789';
        acc1.FirstName__c = 'Abby1';
        acc1.BillingCity='NJ';
        acc1.BillingState='NY';
        acc1.AccountNumber='11789';
        acc1.type = 'Physician';
        acc1.ParentID = acc.ID;
        acc1.AccountType__c = 'Physician';
        acc1.BillingPostalCode = '11789';
        acc1.Speciality__c = '11789Oncology';
        acc1.Alignment_Type__c = 'Direct Aligned';
        acc1.BillingLatitude = 40.5571389900;
        acc1.BillingLongitude = -74.2123329900;
        acc1.External_Country_Id__c = country.id;
        insert acc1;
        
        /*Team_Instance_Account__c teamInstanceAcc1 = CallPlanTestDataFactory.createTeamInstanceAccount(acc1,BaseTeamInstance);
        insert teamInstanceAcc1;
        */
        Position_Account__c posAcc1 = CallPlanTestDataFactory.createPositionAccount(acc1, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc1;
        
        Account acc2 = new Account();
        acc2.Name = '11780';
        acc2.FirstName__c = 'Abby1';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11780';
        acc2.type = 'Physician';
        acc2.ParentID = acc1.ID;
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11780';
        acc2.Speciality__c = '11789Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c = country.id;
        insert acc2;
        
        /*Team_Instance_Account__c teamInstanceAcc2 = CallPlanTestDataFactory.createTeamInstanceAccount(acc2,BaseTeamInstance);
        insert teamInstanceAcc2;*/
        
        Position_Account__c posAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc2;
        
        Account acc3 = new Account();
        acc3.Name = '11781';
        acc3.FirstName__c = 'Abby1';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11781';
        acc3.type = 'Physician';
        acc3.ParentID = acc2.ID;
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11789';
        acc3.Speciality__c = '11789Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c = country.id;
        insert acc3;
        
        /*Team_Instance_Account__c teamInstanceAcc3 = CallPlanTestDataFactory.createTeamInstanceAccount(acc3,BaseTeamInstance);
        insert teamInstanceAcc3;*/
        
        Position_Account__c posAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc3;
        
        Change_Request_Type__c objRequest = CallPlanTestDataFactory.CreateZipRequestType();
        insert objRequest;
        
               
        list<CIM_Config__c> cimList = CallPlanTestDataFactory.createCIMCOnfig(objRequest, BaseTeamInstance,'Position_Geography__c');
        cimList[0].isOptimum__c = true;
        cimList[0].MetricCalculationType__c = 'Absolute';
        insert cimList;
        
        list<CIM_Config__c> OverlaycimList = CallPlanTestDataFactory.createCIMCOnfig(objRequest, OverlayTeamInstance,'Position_Geography__c');
        insert OverlaycimList;
        
        list<CIM_Position_Metric_Summary__c> sourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,territoryTeamInstance,BaseTeamInstance);
        insert sourceCIMSummary;
        
        list<CIM_Position_Metric_Summary__c> destCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,destTerrTeamInstance,BaseTeamInstance);
        insert destCIMSummary;
        
        
        list<CIM_Position_Metric_Summary__c> OverlaysourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(OverlaycimList,OverlaySourceTeamInstance,OverlayTeamInstance);
        insert OverlaysourceCIMSummary;
        
        list<CIM_Position_Metric_Summary__c> OverlaydestCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(OverlaycimList,OverlaydestTerrTeamInstance,OverlayTeamInstance);
        insert OverlaydestCIMSummary;
        
        Related_Position__c SourceRelatedPosition= CallPlanTestDataFactory.createRelatedPos(territoryTeamInstance,OverlaySourceTeamInstance, OverlaySourceterritory, territory );        
        insert SourceRelatedPosition;
        system.debug('SourceRelatedPosition '+SourceRelatedPosition);
        
        
        Related_Position__c DestinationRelatedPosition= CallPlanTestDataFactory.createRelatedPos(destTerrTeamInstance,OverlaydestTerrTeamInstance, OverlaydestTerr, destTerr );
        insert DestinationRelatedPosition;
        system.debug('DestinationRelatedPosition '+DestinationRelatedPosition);
        
        Employee__c emp = CallPlanTestDataFactory.createEmployee();        
        insert emp;
        
        Position_Employee__c posEmp = CallPlanTestDataFactory.createPosEmploye(territory,emp);
        insert posEmp;
        
        Change_Request_Type__c newPositionReqType =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.ROSTER);
        insert newPositionReqType;
        
        TotalApproval__c totalApp = new TotalApproval__c(Name='Approvals',No_Of_Approval__c=3);
        insert totalApp;
        
        TotalApproval__c QuaterName = new TotalApproval__c(Name='Quarter',Subscriber_Profile__c='Orignal');
        insert QuaterName;
        
        list<Profile> hoProfile = [SELECT Id FROM Profile WHERE Name =: SalesIQGlobalConstants.HR_PROFILE limit 1];
        if(hoProfile.size() == 0){
            hoProfile = [SELECT Id FROM Profile WHERE Name = 'System Administrator' limit 1];
        }
        
        User usr = new User(LastName = 'ho',
                            FirstName='test',
                            Alias = 'test',
                            Email = 'test.ho@test.com',
                            Username = 'test.ho@test.com',
                            ProfileId = hoProfile[0].id,
                            TimeZoneSidKey = 'GMT',
                            LanguageLocaleKey = 'en_US',
                            EmailEncodingKey = 'UTF-8',
                            LocaleSidKey = 'en_US');
        insert usr;
        
        Employee__c emp2 = new Employee__c();
        emp2.Name = 'Test Emp2';
        emp2.Employee_ID__c = '12346';
        emp2.Last_Name__c = 'Emp2';
        emp2.FirstName__c = 'Test1';
        emp2.Gender__c = 'M';
        emp2.Change_status__c = 'Pending';
        emp2.USER__c = userinfo.getuserid();
        insert emp2;
        
        Position_Employee__c posEmp2 = new Position_Employee__c();             
        posEmp2.Position__c = territory.id;
        posEmp2.Employee__c = emp2.id;        
        posEmp2.Status__c ='Approved';
        posEmp2.effective_start_date__c = date.today()-3;
        posEmp2.Effective_End_Date__c = date.today()+3;
        posEmp2.Assignment_Type__c = SalesIQGlobalConstants.POSITION_EMPLOYEE_ASSIGNMENT_SECONDARY;
        insert posEmp2;
        
                
        Team_Instance_Object_Attribute__c teamInstAttrImpactTab =  new Team_Instance_Object_Attribute__c();
        teamInstAttrImpactTab.Interface_Name__c = 'Impact ZIP Tab';
        teamInstAttrImpactTab.Attribute_API_Name__c = 'Team_Instance_Geography__r.Geography__r.Zip_Type__c';
        teamInstAttrImpactTab.Object_Name__c = 'Position_Geography__c';
        teamInstAttrImpactTab.Data_Type__c = 'Text';
        teamInstAttrImpactTab.Attribute_Display_Name__c = 'Label.GEO_Type';
        teamInstAttrImpactTab.isEnabled__c=true;
        teamInstAttrImpactTab.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttrImpactTab.Display_Column_Order__c = 1;
        insert teamInstAttrImpactTab;
        
        Team_Instance_Object_Attribute__c teamInstAttrAcInfo =  new Team_Instance_Object_Attribute__c();
        teamInstAttrAcInfo.Interface_Name__c = 'AccInfo';
        teamInstAttrAcInfo.Attribute_API_Name__c = 'Position__r.Name';
        teamInstAttrAcInfo.Object_Name__c = 'Position_Account__c';
        teamInstAttrAcInfo.Data_Type__c = 'Text';
        teamInstAttrAcInfo.Attribute_Display_Name__c = 'Position';
        teamInstAttrAcInfo.isEnabled__c=true;
        teamInstAttrAcInfo.Section__c='Assignment Information';
        teamInstAttrAcInfo.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttrAcInfo.Display_Column_Order__c = 2;
        insert teamInstAttrAcInfo;
        
        Team_Instance_Object_Attribute__c teamInstAttrZIPInfo =  new Team_Instance_Object_Attribute__c();
        teamInstAttrZIPInfo.Interface_Name__c = 'ZIPInfo';
        teamInstAttrZIPInfo.Attribute_API_Name__c = 'Position__r.Name';
        teamInstAttrZIPInfo.Object_Name__c = 'Position_Geography__c';
        teamInstAttrZIPInfo.Data_Type__c = 'Text';
        teamInstAttrZIPInfo.Section__c = 'Metrics';
        teamInstAttrZIPInfo.Attribute_Display_Name__c = 'Territory';
        teamInstAttrZIPInfo.isEnabled__c=true;
        teamInstAttrZIPInfo.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttrZIPInfo.Display_Column_Order__c = 1;
        insert teamInstAttrZIPInfo;   

        list<Team_Instance_Object_Attribute__c> allTeamAttrConfig  =new list<Team_Instance_Object_Attribute__c>();
        Team_Instance_Object_Attribute__c teamInstAttrStartDate =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ALIGNMENT_CONFIRMATION_POPUP_INTERFACE_NAME,'IC_EffstartDate__c','Team_Instance__c','Start Date',true,true,1);       
        //insert teamInstAttrStartDate;
        allTeamAttrConfig.add(teamInstAttrStartDate);
        
        
        Team_Instance_Object_Attribute__c teamInstAttrEndDate =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ALIGNMENT_CONFIRMATION_POPUP_INTERFACE_NAME,'IC_EffEndDate__c','Team_Instance__c','EndDate Date',true,true,2);       
        //insert teamInstAttrEndDate;
        allTeamAttrConfig.add(teamInstAttrEndDate);

        Team_Instance_Object_Attribute__c teamInstAttrAccountSortField =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, 'Map Account Sort Field','Metric2__c','Position_Account__c','Sales',true,true,1);       
        //insert teamInstAttrAccountSortField;
        allTeamAttrConfig.add(teamInstAttrAccountSortField);

        Team_Instance_Object_Attribute__c teamInstAttrPositionName =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.INTERFACE_NAME_POSITION_LIST_VIEW,'Name','Position__c','Position Name',true,true,1);       
        //insert teamInstAttrPositionName;
        allTeamAttrConfig.add(teamInstAttrPositionName);

        //Team_Instance_Object_Attribute__c teamInstAttrPositionCode =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.INTERFACE_NAME_POSITION_LIST_VIEW,'Client_Position_Code__c','Position__c','Position Code',true,true,1);       
        //insert teamInstAttrPositionCode;
        //allTeamAttrConfig.add(teamInstAttrPositionCode);

        Team_Instance_Object_Attribute__c teamInstAttrZIPPositionCode =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP,'Position__c','Position_Geography__c','Position Code',true,true,1);       
        //insert teamInstAttrZIPPositionCode;
        allTeamAttrConfig.add(teamInstAttrZIPPositionCode);

        Team_Instance_Object_Attribute__c teamInstAttrCreatePositionIsEditable =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP,'Client_Position_Code__c','Position__c','Position Code',true,true,1);       
        //insert teamInstAttrCreatePositionIsEditable;
        allTeamAttrConfig.add(teamInstAttrCreatePositionIsEditable);

        Team_Instance_Object_Attribute__c teamInstAttrCreatePositionIsReadable =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP,'Name','Position__c','Position Name',true,false,2);       
        //insert teamInstAttrCreatePositionIsReadable;
        allTeamAttrConfig.add(teamInstAttrCreatePositionIsReadable);

        Team_Instance_Object_Attribute__c teamInstAttrImpactAccountTab =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ACCOUNT_IMPACT_TAB,'Team_Instance_Account__r.Account_ID__r.Name','Position_Account__c','Position Name',true,true,1);       
        //insert teamInstAttrImpactAccountTab;
        allTeamAttrConfig.add(teamInstAttrImpactAccountTab);

        Team_Instance_Object_Attribute__c teamInstAttrAccountRendring =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ACCOUNT_RENDERING_INTERFACE_NAME,'Metric1__c','Position_Account__c','PAlignment Index',true,true,1);       
        //insert teamInstAttrAccountRendring;
        allTeamAttrConfig.add(teamInstAttrAccountRendring);
        
        insert allTeamAttrConfig;

        list<Team_Instance_Object_Attribute_Detail__c> attrDetails  = new list<Team_Instance_Object_Attribute_Detail__c>();
        Team_Instance_Object_Attribute_Detail__c accountRendringLowDetails = CallPlanTestDataFactory.createAttributesDetails(teamInstAttrAccountRendring, BaseTeamInstance, 'LOW','1');
        attrDetails.add(accountRendringLowDetails);

        Team_Instance_Object_Attribute_Detail__c accountRendringMediumDetails = CallPlanTestDataFactory.createAttributesDetails(teamInstAttrAccountRendring, BaseTeamInstance, 'MEDIUM','2');
        attrDetails.add(accountRendringMediumDetails);

        insert attrDetails;
        
        ETL_Config__c objETL = new ETL_Config__c();
        objETL.Name = SalesIQGlobalConstants.VALIDATE_CONTIGUITY_AND_DOUGHNUT;
        objETL.End_Point__c = 'https://gisdev.axtria.com/api/validateContiguityANDDoughnut?';
        insert objETL;





     //   map<String,list<Team_Instance_Object_Attribute_Detail__c>> renderattri = ScenarioAlignmentCtlr.getAccountRenderingAttributes(BaseTeamInstance.Id);
        //list<User_Access_Permission__c> lsUsers = ScenarioAlignmentCtlr.getTeamAndTeamInstances();
        
        
        
        CR_Approval_Config__c appConfig = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = objRequest.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = true);
        insert appConfig;



        list<CR_Team_Instance_Config__c> allConfig = new list<CR_Team_Instance_Config__c>();
        CR_Team_Instance_Config__c objConfigZIP  =CallPlanTestDataFactory.LayerConfig('Level 0',SalesIQGlobalConstants.LAYER_CONFIG,'ZIP',true,BaseTeamInstance);
        allConfig.add(objConfigZIP);

        CR_Team_Instance_Config__c objConfigTerr  =CallPlanTestDataFactory.LayerConfig('Level 1',SalesIQGlobalConstants.LAYER_CONFIG,'Territory',false,BaseTeamInstance);
        allConfig.add(objConfigTerr);

        CR_Team_Instance_Config__c objConfigAccount  =CallPlanTestDataFactory.LayerConfig('Account',SalesIQGlobalConstants.LAYER_CONFIG,'Account',true,BaseTeamInstance);
        allConfig.add(objConfigAccount);

        CR_Team_Instance_Config__c objConfigHierarchyTerritory  =CallPlanTestDataFactory.LayerConfig('1',SalesIQGlobalConstants.HIERARCHY_CONFIG,'Territory',false,BaseTeamInstance);
        allConfig.add(objConfigHierarchyTerritory);

        CR_Team_Instance_Config__c objConfigHierarchyDistrict  =CallPlanTestDataFactory.LayerConfig('2',SalesIQGlobalConstants.HIERARCHY_CONFIG,'District',false,BaseTeamInstance);
        allConfig.add(objConfigHierarchyDistrict);

        CR_Team_Instance_Config__c objConfigNonFieldPosition  =CallPlanTestDataFactory.LayerConfig('Config Name','Non Field Position Type','Config Value',false,null);
        objConfigNonFieldPosition.create__c = true;
        objConfigNonFieldPosition.edit__c = true;
        objConfigNonFieldPosition.delete__c = false;
        allConfig.add(objConfigNonFieldPosition);

        insert allConfig;
            test.startTest();
            ScenarioAlignmentCtlr.getBreadcrumbData();
            ScenarioAlignmentCtlr.getScenarioDetails(BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.getPositionHierarchy(BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.getPositionAccount(BaseTeamInstance.Id, new List<String>{territory.Client_Position_Code__c},1,territoryTeamInstance.X_Min__c,territoryTeamInstance.X_Max__c,territoryTeamInstance.Y_Min__c,territoryTeamInstance.Y_Max__c);
            ScenarioAlignmentCtlr.getAccountInfoAttributes(BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.changePositionColor(territory.Client_Position_Code__c,BaseTeamInstance.Id,territory.RGB__c);
            ScenarioAlignmentCtlr.getInfoPopupDetails('AccInfo',BaseTeamInstance.Id,acc.AccountNumber,'Current',new List<String>());
            ScenarioAlignmentCtlr.getInfoPopupDetails('ZIPInfo',BaseTeamInstance.Id,geo1.Name,'Current',new List<String>());
            ScenarioAlignmentCtlr.checkContinguityandDoughnut(BaseTeamInstance.Id,territory.Client_Position_Code__c,destTerr.Client_Position_Code__c,geo1.Name);
            ScenarioAlignmentCtlr.checkAccountAffliationLimit(acc.AccountNumber,True);
            ScenarioAlignmentCtlr.checkAccountAffliationLimit(acc.AccountNumber,False);
            ScenarioAlignmentCtlr.checkExternalValidation(BaseTeamInstance.Id,geo2.Name,acc2.AccountNumber,territory.Client_Position_Code__c,destTerr.Client_Position_Code__c,'Account');
            ScenarioAlignmentCtlr.checkExternalValidation(BaseTeamInstance.Id,geo2.Name,acc2.AccountNumber,territory.Client_Position_Code__c,destTerr.Client_Position_Code__c,'ZIP');
            ScenarioAlignmentCtlr.positionRulesMismatchValidation(territory.Id,destTerr.Id,BaseTeamInstance.Id,'Current',True);
            ScenarioAlignmentCtlr.positionRulesMismatchValidation(territory.Id,destTerr.Id,BaseTeamInstance.Id,'Current',False);
            ScenarioAlignmentCtlr.enableOverlayImpactData(geo1.Name,acc1.AccountNumber,territory.Id,destTerr.Id,'Hybrid','Current','ZIP',BaseTeamInstance.Id);
            test.stopTest();
    }
    
    static testMethod void testZIPAlignment1(){
        //Creating custom setting test data
        ReadOnlyApplication__c setting  = new ReadOnlyApplication__c();
        setting.Alignment__c = false;
        setting.Secondary_Assignment_Alignment__c = true;
        insert setting;
        
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;
        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;
        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;
        
         list<DiplayColorCriteria__c> colorSettings = new list<DiplayColorCriteria__c>();
        colorSettings.add(new DiplayColorCriteria__c(Name='Error',Color__c='#F8CBAD'));
        colorSettings.add(new DiplayColorCriteria__c(Name='Normal',Color__c='#FFFFFF'));
        colorSettings.add(new DiplayColorCriteria__c(Name='Warning',Color__c='#ffE699'));
        insert colorSettings;
        
        Team__c baseTeam = new Team__c(Name='HTN',Type__c='Base',Effective_End_Date__c=Date.today().addMonths(50),Country__c=country.id);
        insert baseTeam;
        
        Team__c overlayTeam = new Team__c(Name='HTN Overlay',Type__c='Overlay',Controlling_Team__c= baseTeam.id,Country__c=country.id);
        insert overlayTeam;
        
        Workspace__c wrk = new Workspace__c();
        wrk.Workspace_Start_Date__c = Date.Today();
        wrk.Workspace_End_Date__c  = Date.today().addMonths(50);
        wrk.Name = 'Workspace 1';
        wrk.Workspace_Description__c = 'New Workspace';
        wrk.Country__c=country.id;
        insert wrk;
        
        
        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = false;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrk.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;
        scenario.Scenario_Stage__c =    SalesIQGlobalConstants.COLLABORATION;    
        scenario.Scenario_Type__c = SalesIQGlobalConstants.SCENARIO_TYPE_ALIGNMENT;
        scenario.Scenario_Status__c = SalesIQGlobalConstants.SCENARIO_STATUS_ACTIVE;
        insert scenario;

        Business_Rule_Type_Master__c brtm = new Business_Rule_Type_Master__c();
        brtm.name = 'Assignment Rules';
        insert brtm;

        Team_Instance__c BaseTeamInstance = new Team_Instance__c();
        BaseTeamInstance.Name = 'HTN_Q1_2016';
        BaseTeamInstance.Alignment_Period__c = 'Current';
        BaseTeamInstance.Team__c = baseTeam.id;
        BaseTeamInstance.Alignment_Type__c = 'ZIP';
        BaseTeamInstance.isActiveCycle__c = 'Y';  
        BaseTeamInstance.Team_Cycle_Name__c = 'Current';
        BaseTeamInstance.Scenario__c  = scenario.id;  
        BaseTeamInstance.Team_Instance_Code__c = 'DI-00001'; 
        BaseTeamInstance.IC_EffstartDate__c = Date.today().addMonths(-1);
        BaseTeamInstance.IC_EffEndDate__c = Date.today().addYears(1);       
        BaseTeamInstance.Show_Custom_Metric__c=true;
        BaseTeamInstance.Geography_Type_Name__c = geotype.id;
        BaseTeamInstance.doContiguityCheck__c = true;
        BaseTeamInstance.doDoughnutCheck__c = true;
        BaseTeamInstance.CIM_available__c = true;

        insert BaseTeamInstance;
        
        Team_Instance__c OverlayTeamInstance = new Team_Instance__c();
        OverlayTeamInstance.Name = 'Overlay HTN 2016';
        OverlayTeamInstance.Alignment_Period__c = 'Current';
        OverlayTeamInstance.Team__c = overlayTeam.id;
        OverlayTeamInstance.Alignment_Type__c = 'ZIP';
        OverlayTeamInstance.isActiveCycle__c = 'Y'; 
        OverlayTeamInstance.Team_Instance_Code__c = 'DI-00002';
        OverlayTeamInstance.IC_EffstartDate__c = Date.today().addMonths(-1);
        OverlayTeamInstance.IC_EffEndDate__c = Date.today().addYears(1);  
        insert OverlayTeamInstance;
        
                
        Position__c nation = new Position__c();
        nation.name = 'USA';
        nation.Client_Territory_Name__c = 'North east';
        nation.Client_Position_Code__c = '1NE30000';
        nation.Client_Territory_Code__c='1NE30000';
        nation.Position_Type__c='Nation';
        nation.inactive__c = false;
        nation.RGB__c = '41,210,117';
        nation.Team_iD__c = baseTeam.id;
        nation.Hierarchy_Level__c='4';
        nation.Related_Position_Type__c  ='Base';
        nation.Effective_End_Date__c=Date.today().addMonths(50);
        nation.Team_Instance__c = BaseTeamInstance.id;
        nation.Position_Category__c = 'Field Position';
        insert nation;
        
        Position__c region = new Position__c();
        region.name = 'North east';
        region.Client_Territory_Name__c = 'North east';
        region.Client_Position_Code__c = '1NE30000';
        region.Client_Territory_Code__c='1NE30000';
        region.Position_Type__c='Region';
        region.inactive__c = false;
        region.RGB__c = '41,210,117';
        region.Team_iD__c = baseTeam.id;
        region.Effective_End_Date__c=Date.today().addMonths(50);
        region.Hierarchy_Level__c = '3';
        region.Related_Position_Type__c  ='Base';
        region.Team_Instance__c = BaseTeamInstance.id;
        region.Position_Category__c = 'Field Position';
        insert region;
        
        Position_Team_Instance__c regionTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(region, null, BaseTeamInstance);
        regionTeamInstance.X_Max__c=-72.6966429900;
        regionTeamInstance.X_Min__c=-73.9625820000;
        regionTeamInstance.Y_Max__c=40.9666490000;
        regionTeamInstance.Y_Min__c=40.5821279800;
        insert regionTeamInstance;
        
        Position__c district = new Position__c();
        district.name = 'Newyork';
        district.Client_Territory_Name__c = 'Newyork';
        district.Client_Position_Code__c = '1NE30001';
        district.Client_Territory_Code__c='1NE30001';
        district.Position_Type__c='District';
        district.inactive__c = false;
        district.RGB__c = '41,210,117';
        district.Team_iD__c = baseTeam.id;
        district.Parent_Position__c = region.Id;
        district.Hierarchy_Level__c='2';
        district.Related_Position_Type__c  ='Base';
        district.Effective_End_Date__c=Date.today().addMonths(50);
        district.Team_Instance__c = BaseTeamInstance.id;
        district.Position_Category__c = 'Field Position';
        insert district;
        
        Position_Team_Instance__c districtTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(district, region, BaseTeamInstance);
        districtTeamInstance.X_Max__c=-72.6966429900;
        districtTeamInstance.X_Min__c=-73.9625820000;
        districtTeamInstance.Y_Max__c=40.9666490000;
        districtTeamInstance.Y_Min__c=40.5821279800;
        insert districtTeamInstance;
        
        Position__c territory = new Position__c();
        territory.name = 'Long Island East';
        territory.Client_Territory_Name__c = 'Long Island East';
        territory.Client_Position_Code__c = '1NE30011';
        territory.Client_Territory_Code__c='1NE30011';
        territory.Position_Type__c='Territory';
        territory.inactive__c = false;
        territory.RGB__c = '41,210,117';
        territory.Team_iD__c = baseTeam.id;
        territory.Parent_Position__c = district.Id; 
        territory.Effective_Start_Date__c=Date.today();       
        territory.Effective_End_Date__c=Date.today().addMonths(50);
        territory.Related_Position_Type__c = 'Base';
        territory.Hierarchy_Level__c = '1'; 
        territory.Team_Instance__c =  BaseTeamInstance.id;
        territory.Position_Category__c = 'Field Position';
        insert territory;
        
        Position__c OverlaySourceterritory = new Position__c();
        OverlaySourceterritory.name = 'Long Island East';
        OverlaySourceterritory.Client_Territory_Name__c = 'Long Island East';
        OverlaySourceterritory.Client_Position_Code__c = '1NE30011';
        OverlaySourceterritory.Client_Territory_Code__c='1NE30011';
        OverlaySourceterritory.Position_Type__c='Territory';
        OverlaySourceterritory.inactive__c = false;
        OverlaySourceterritory.RGB__c = '41,210,117';
        OverlaySourceterritory.Team_iD__c = overlayTeam.id;
        OverlaySourceterritory.Parent_Position__c = district.Id;
        OverlaySourceterritory.Effective_End_Date__c=Date.today().addMonths(50);
        OverlaySourceterritory.Related_Position_Type__c = 'Overlay';
        OverlaySourceterritory.Hierarchy_Level__c = '1';
        OverlaySourceterritory.Position_Category__c = 'Field Position';
        insert OverlaySourceterritory;
        
        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, district, BaseTeamInstance);
        territoryTeamInstance.X_Max__c=-72.6966429900;
        territoryTeamInstance.X_Min__c=-73.9625820000;
        territoryTeamInstance.Y_Max__c=40.9666490000;
        territoryTeamInstance.Y_Min__c=40.5821279800;
        insert territoryTeamInstance;
        
        Position_Team_Instance__c OverlaySourceTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(OverlaySourceterritory, district, OverlayTeamInstance);
        OverlaySourceTeamInstance.X_Max__c=-72.6966429900;
        OverlaySourceTeamInstance.X_Min__c=-73.9625820000;
        OverlaySourceTeamInstance.Y_Max__c=40.9666490000;
        OverlaySourceTeamInstance.Y_Min__c=40.5821279800;
        insert OverlaySourceTeamInstance;
        
        Position__c destTerr = new Position__c();
        destTerr.Name = 'Long Island West';
        destTerr.Client_Territory_Name__c = 'Long Island West';
        destTerr.Client_Position_Code__c = '1NE30012';
        destTerr.Client_Territory_Code__c='1NE30012';
        destTerr.Position_Type__c='Territory';
        destTerr.inactive__c = false;
        destTerr.RGB__c = '41,210,117';
        destTerr.Team_iD__c = baseTeam.id;
        destTerr.Parent_Position__c = district.Id;
        destTerr.Hierarchy_Level__c = '1';
        destTerr.Related_Position_Type__c  ='Base';
        destTerr.Effective_End_Date__c=Date.today().addMonths(50);
        destTerr.Team_Instance__c = BaseTeamInstance.id;
        destTerr.Position_Category__c = 'Field Position';
        insert destTerr;
        
        Position__c OverlaydestTerr = new Position__c();
        OverlaydestTerr.Name = 'Long Island West';
        OverlaydestTerr.Client_Territory_Name__c = 'Long Island West';
        OverlaydestTerr.Client_Position_Code__c = '1NE30012';
        OverlaydestTerr.Client_Territory_Code__c='1NE30012';
        OverlaydestTerr.Position_Type__c='Territory';
        OverlaydestTerr.inactive__c = false;
        OverlaydestTerr.RGB__c = '41,210,117';
        OverlaydestTerr.Team_iD__c = overlayTeam.id;
        OverlaydestTerr.Parent_Position__c = district.Id;
        OverlaydestTerr.Hierarchy_Level__c = '1';
        OverlaydestTerr.Related_Position_Type__c  ='Overlay';
        OverlaydestTerr.Effective_End_Date__c=Date.today().addMonths(50);
        OverlaydestTerr.Position_Category__c = 'Field Position';
        insert OverlaydestTerr;
        
        Position_Team_Instance__c destTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerr, district, BaseTeamInstance);
        destTerrTeamInstance.X_Max__c=-72.6966429900;
        destTerrTeamInstance.X_Min__c=-73.9625820000;
        destTerrTeamInstance.Y_Max__c=40.9666490000;
        destTerrTeamInstance.Y_Min__c=40.5821279800;
        insert destTerrTeamInstance;
        
        Position_Team_Instance__c OverlaydestTerrTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(OverlaydestTerr, district, OverlayTeamInstance);
        OverlaydestTerrTeamInstance.X_Max__c=-72.6966429900;
        OverlaydestTerrTeamInstance.X_Min__c=-73.9625820000;
        OverlaydestTerrTeamInstance.Y_Max__c=40.9666490000;
        OverlaydestTerrTeamInstance.Y_Min__c=40.5821279800;
        insert OverlaydestTerrTeamInstance;
        
        User_Access_Permission__c access = new User_Access_Permission__c();
        access.Position__c = region.id;
        access.Map_Access_Position__c = region.id;
        access.name='access';
        access.Team_Instance__c = BaseTeamInstance.id;   
        access.User__c = UserInfo.getUserId();
        access.Is_Active__c = true;
        insert access;
        
        User_Access_Permission__c Overlayaccess = new User_Access_Permission__c();
        Overlayaccess.Position__c = region.id;
        Overlayaccess.Map_Access_Position__c = region.id;
        Overlayaccess.name='Overlayaccess';
        Overlayaccess.Team_Instance__c = OverlayTeamInstance.id;   
        Overlayaccess.User__c = UserInfo.getUserId();
        Overlayaccess.Is_Active__c = true;
        insert Overlayaccess;
        
        Geography__c geo1 = new Geography__c();
        geo1.Name = '11788';
        geo1.City__c='Test 11788';
        geo1.State__c = '11788';
        geo1.Neighbor_Geography__c = '11789';
        geo1.Zip_Type__c = 'Standard';
        geo1.Centroid_Latitude__c = 0.0;
        geo1.Centroid_Longitude__c = 0.0;
        geo1.External_Country_Id__c=country.id;
        geo1.External_Geo_Type__c= geotype.id;
        geo1.Geography_Type__c= geotype.id;
        insert geo1; 

        
        
        Position_Geography__c posGeo1  = new Position_Geography__c();
        posGeo1.Effective_Start_Date__c  = Date.today().addMonths(-1);
        posGeo1.Effective_End_Date__c  = Date.today().addYears(1);
        posGeo1.Geography__c = geo1.id;     
        posGeo1.Position__c = territory.id;
        posGeo1.Team_Instance__c = BaseTeamInstance.id ;
        posGeo1.Position_Team_Instance__c = territoryTeamInstance.id;
        posGeo1.Change_Status__c = 'No Change';
        posGeo1.Metric1__c  =2.010000000000;
        posGeo1.Metric2__c  =29.000000000000;
        posGeo1.Metric3__c  =2.000000000000;
        posGeo1.Metric4__c  =1.431479545000;
        posGeo1.Metric5__c  =1.490000000000;
        posGeo1.Metric6__c  =2.010000000000;
        posGeo1.Metric7__c  =29.000000000000;
        posGeo1.Metric8__c  =2.000000000000;
        posGeo1.Metric9__c  =1.431479545000;
        posGeo1.Metric10__c =1.490000000000;
        insert posGeo1;
        
        Position_Geography__c OverlayPositionGeoSource  = new Position_Geography__c();
        OverlayPositionGeoSource.Effective_Start_Date__c  = Date.today().addMonths(-1);
        OverlayPositionGeoSource.Effective_End_Date__c  = Date.today().addYears(1);
        OverlayPositionGeoSource.Geography__c = geo1.id;
        OverlayPositionGeoSource.Position__c = OverlaySourceterritory.id;
        OverlayPositionGeoSource.Team_Instance__c = OverlayTeamInstance.id ;
        OverlayPositionGeoSource.Position_Team_Instance__c = OverlaySourceTeamInstance.id;
        OverlayPositionGeoSource.Change_Status__c = 'No Change';
        OverlayPositionGeoSource.Metric1__c  =2.010000000000;
        OverlayPositionGeoSource.Metric2__c  =29.000000000000;
        OverlayPositionGeoSource.Metric3__c  =2.000000000000;
        OverlayPositionGeoSource.Metric4__c  =1.431479545000;
        OverlayPositionGeoSource.Metric5__c  =1.490000000000;
        OverlayPositionGeoSource.Metric6__c  =2.010000000000;
        OverlayPositionGeoSource.Metric7__c  =29.000000000000;
        OverlayPositionGeoSource.Metric8__c  =2.000000000000;
        OverlayPositionGeoSource.Metric9__c  =1.431479545000;
        OverlayPositionGeoSource.Metric10__c =1.490000000000;
        insert OverlayPositionGeoSource;
        
        Business_Rules__c br =  new Business_Rules__c();
        br.Rule_Level__c = 'Position'; 
        br.Scenario__c = scenario.Id;
        br.Selected_Positions__c = territory.Id;
        br.Business_Rule_Type_Master__c = brtm.id;
        insert br;
        
        
        Geography__c geo2 = new Geography__c();
        geo2.Name = '11789';
        geo2.City__c='Test 11789';
        geo2.State__c = '11789';
        //geo2.Neighbor_Geography__c = '11788';
        geo2.Centroid_Latitude__c = 0.0;
        geo2.Centroid_Longitude__c = 0.0;
        geo2.Zip_Type__c = 'Point';
        geo2.Parent_Zip_Code__c = geo1.Id;
        geo2.External_Country_Id__c=country.id;
        geo2.External_Geo_Type__c= geotype.id;
        geo2.Geography_Type__c= geotype.id;
        insert geo2; 
        
        /*Team_Instance_Geography__c teamInsGeo2 = new Team_Instance_Geography__c();
        teamInsGeo2.Geography__c = geo2.id;
        teamInsGeo2.Team_Instance__c = BaseTeamInstance.id;
        teamInsGeo2.Effective_Start_Date__c = Date.today().addMonths(-1);
        teamInsGeo2.Effective_End_Date__c = Date.today().addYears(1);
        teamInsGeo2.Metric1__c  =2.010000000000;
        teamInsGeo2.Metric2__c  =29.000000000000;
        teamInsGeo2.Metric3__c  =2.000000000000;
        teamInsGeo2.Metric4__c  =1.431479545000;
        teamInsGeo2.Metric5__c  =1.490000000000;
        teamInsGeo2.Metric6__c  =2.010000000000;
        teamInsGeo2.Metric7__c  =29.000000000000;
        teamInsGeo2.Metric8__c  =2.000000000000;
        teamInsGeo2.Metric9__c  =1.431479545000;
        teamInsGeo2.Metric10__c =1.490000000000;
        insert teamInsGeo2;*/
        
        /*Team_Instance_Geography__c OverlayteamInsGeo2 = new Team_Instance_Geography__c();
        OverlayteamInsGeo2.Geography__c = geo2.id;
        OverlayteamInsGeo2.Team_Instance__c = OverlayTeamInstance.id;
        OverlayteamInsGeo2.Effective_Start_Date__c = Date.today().addMonths(-1);
        OverlayteamInsGeo2.Effective_End_Date__c = Date.today().addYears(1);
        OverlayteamInsGeo2.Metric1__c  =2.010000000000;
        OverlayteamInsGeo2.Metric2__c  =29.000000000000;
        OverlayteamInsGeo2.Metric3__c  =2.000000000000;
        OverlayteamInsGeo2.Metric4__c  =1.431479545000;
        OverlayteamInsGeo2.Metric5__c  =1.490000000000;
        OverlayteamInsGeo2.Metric6__c  =2.010000000000;
        OverlayteamInsGeo2.Metric7__c  =29.000000000000;
        OverlayteamInsGeo2.Metric8__c  =2.000000000000;
        OverlayteamInsGeo2.Metric9__c  =1.431479545000;
        OverlayteamInsGeo2.Metric10__c =1.490000000000;
        insert OverlayteamInsGeo2;*/
        
        Position_Geography__c posGeo2  = new Position_Geography__c();
        posGeo2.Effective_Start_Date__c  = Date.today().addMonths(-1);
        posGeo2.Effective_End_Date__c  = Date.today().addYears(1);
        posGeo2.Geography__c = geo2.id;
        posGeo2.Position__c = territory.id;
        posGeo2.Team_Instance__c = BaseTeamInstance.id ;
        //posGeo2.Team_Instance_Geography__c = teamInsGeo2.id;
        posGeo2.Position_Team_Instance__c = territoryTeamInstance.id;
        posGeo2.Change_Status__c = 'No Change';
        posGeo2.Metric1__c  =2.010000000000;
        posGeo2.Metric2__c  =29.000000000000;
        posGeo2.Metric3__c  =2.000000000000;
        posGeo2.Metric4__c  =1.431479545000;
        posGeo2.Metric5__c  =1.490000000000;
        posGeo2.Metric6__c  =2.010000000000;
        posGeo2.Metric7__c  =29.000000000000;
        posGeo2.Metric8__c  =2.000000000000;
        posGeo2.Metric9__c  =1.431479545000;
        posGeo2.Metric10__c =1.490000000000;
        insert posGeo2;
        
        Position_Geography__c OverlayDestinationposGeo2  = new Position_Geography__c();
        OverlayDestinationposGeo2.Effective_Start_Date__c  = Date.today().addMonths(-1);
        OverlayDestinationposGeo2.Effective_End_Date__c  = Date.today().addYears(1);
        OverlayDestinationposGeo2.Geography__c = geo2.id;
        OverlayDestinationposGeo2.Position__c = OverlaydestTerr.id;
        OverlayDestinationposGeo2.Team_Instance__c = OverlayTeamInstance.id ;
        //OverlayDestinationposGeo2.Team_Instance_Geography__c = OverlayteamInsGeo2.id;
        OverlayDestinationposGeo2.Position_Team_Instance__c = OverlaydestTerrTeamInstance.id;
        OverlayDestinationposGeo2.Change_Status__c = 'No Change';
        OverlayDestinationposGeo2.Metric1__c  =2.010000000000;
        OverlayDestinationposGeo2.Metric2__c  =29.000000000000;
        OverlayDestinationposGeo2.Metric3__c  =2.000000000000;
        OverlayDestinationposGeo2.Metric4__c  =1.431479545000;
        OverlayDestinationposGeo2.Metric5__c  =1.490000000000;
        OverlayDestinationposGeo2.Metric6__c  =2.010000000000;
        OverlayDestinationposGeo2.Metric7__c  =29.000000000000;
        OverlayDestinationposGeo2.Metric8__c  =2.000000000000;
        OverlayDestinationposGeo2.Metric9__c  =1.431479545000;
        OverlayDestinationposGeo2.Metric10__c =1.490000000000;
        insert OverlayDestinationposGeo2;
        
        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'Physician';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c = country.id;
        insert acc;
        
        /*Team_Instance_Account__c teamInstanceAcc = CallPlanTestDataFactory.createTeamInstanceAccount(acc,BaseTeamInstance);
        insert teamInstanceAcc;*/
        
        Position_Account__c posAcc = CallPlanTestDataFactory.createPositionAccount(acc, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc;
                
        Account acc1 = new Account();
        acc1.Name = '11789';
        acc1.FirstName__c = 'Abby1';
        acc1.BillingCity='NJ';
        acc1.BillingState='NY';
        acc1.AccountNumber='11789';
        acc1.type = 'Physician';
        acc1.ParentID = acc.ID;
        acc1.AccountType__c = 'Physician';
        acc1.BillingPostalCode = '11789';
        acc1.Speciality__c = '11789Oncology';
        acc1.Alignment_Type__c = 'Direct Aligned';
        acc1.BillingLatitude = 40.5571389900;
        acc1.BillingLongitude = -74.2123329900;
        acc1.External_Country_Id__c = country.id;
        insert acc1;
        
        /*Team_Instance_Account__c teamInstanceAcc1 = CallPlanTestDataFactory.createTeamInstanceAccount(acc1,BaseTeamInstance);
        insert teamInstanceAcc1;
        */
        Position_Account__c posAcc1 = CallPlanTestDataFactory.createPositionAccount(acc1, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc1;
        
        Account acc2 = new Account();
        acc2.Name = '11780';
        acc2.FirstName__c = 'Abby1';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11780';
        acc2.type = 'Physician';
        acc2.ParentID = acc1.ID;
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11780';
        acc2.Speciality__c = '11789Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c = country.id;
        insert acc2;
        
        /*Team_Instance_Account__c teamInstanceAcc2 = CallPlanTestDataFactory.createTeamInstanceAccount(acc2,BaseTeamInstance);
        insert teamInstanceAcc2;*/
        
        Position_Account__c posAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc2;
        
        Account acc3 = new Account();
        acc3.Name = '11781';
        acc3.FirstName__c = 'Abby1';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11781';
        acc3.type = 'Physician';
        acc3.ParentID = acc2.ID;
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11789';
        acc3.Speciality__c = '11789Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c = country.id;
        insert acc3;
        
        /*Team_Instance_Account__c teamInstanceAcc3 = CallPlanTestDataFactory.createTeamInstanceAccount(acc3,BaseTeamInstance);
        insert teamInstanceAcc3;
        */
        Position_Account__c posAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, BaseTeamInstance, territoryTeamInstance);
        insert posAcc3;
        
        Change_Request_Type__c objRequest = CallPlanTestDataFactory.CreateZipRequestType();
        insert objRequest;
        
               
        list<CIM_Config__c> cimList = CallPlanTestDataFactory.createCIMCOnfig(objRequest, BaseTeamInstance,'Position_Geography__c');
        cimList[0].isOptimum__c = true;
        cimList[0].MetricCalculationType__c = 'Absolute';
        insert cimList;
        
        list<CIM_Config__c> OverlaycimList = CallPlanTestDataFactory.createCIMCOnfig(objRequest, OverlayTeamInstance,'Position_Geography__c');
        insert OverlaycimList;
        
        list<CIM_Position_Metric_Summary__c> sourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,territoryTeamInstance,BaseTeamInstance);
        insert sourceCIMSummary;
        
        list<CIM_Position_Metric_Summary__c> destCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,destTerrTeamInstance,BaseTeamInstance);
        insert destCIMSummary;
        
        
        list<CIM_Position_Metric_Summary__c> OverlaysourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(OverlaycimList,OverlaySourceTeamInstance,OverlayTeamInstance);
        insert OverlaysourceCIMSummary;
        
        list<CIM_Position_Metric_Summary__c> OverlaydestCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(OverlaycimList,OverlaydestTerrTeamInstance,OverlayTeamInstance);
        insert OverlaydestCIMSummary;
        
        Related_Position__c SourceRelatedPosition= CallPlanTestDataFactory.createRelatedPos(territoryTeamInstance,OverlaySourceTeamInstance, OverlaySourceterritory, territory );        
        insert SourceRelatedPosition;
        system.debug('SourceRelatedPosition '+SourceRelatedPosition);
        
        
        Related_Position__c DestinationRelatedPosition= CallPlanTestDataFactory.createRelatedPos(destTerrTeamInstance,OverlaydestTerrTeamInstance, OverlaydestTerr, destTerr );
        insert DestinationRelatedPosition;
        system.debug('DestinationRelatedPosition '+DestinationRelatedPosition);
        
        Employee__c emp = CallPlanTestDataFactory.createEmployee();        
        insert emp;
        
        Position_Employee__c posEmp = CallPlanTestDataFactory.createPosEmploye(territory,emp);
        insert posEmp;
        
        Change_Request_Type__c newPositionReqType =  CallPlanTestDataFactory.CreateRequestType(SalesIQGlobalConstants.ROSTER);
        insert newPositionReqType;
        
        TotalApproval__c totalApp = new TotalApproval__c(Name='Approvals',No_Of_Approval__c=3);
        insert totalApp;
        
        TotalApproval__c QuaterName = new TotalApproval__c(Name='Quarter',Subscriber_Profile__c='Orignal');
        insert QuaterName;
        
        list<Profile> hoProfile = [SELECT Id FROM Profile WHERE Name =: SalesIQGlobalConstants.HR_PROFILE limit 1];
        if(hoProfile.size() == 0){
            hoProfile = [SELECT Id FROM Profile WHERE Name = 'System Administrator' limit 1];
        }
        
        User usr = new User(LastName = 'ho',
                            FirstName='test',
                            Alias = 'test',
                            Email = 'test.ho@test.com',
                            Username = 'test.ho@test.com',
                            ProfileId = hoProfile[0].id,
                            TimeZoneSidKey = 'GMT',
                            LanguageLocaleKey = 'en_US',
                            EmailEncodingKey = 'UTF-8',
                            LocaleSidKey = 'en_US');
        insert usr;
        
        Employee__c emp2 = new Employee__c();
        emp2.Name = 'Test Emp2';
        emp2.Employee_ID__c = '12346';
        emp2.Last_Name__c = 'Emp2';
        emp2.FirstName__c = 'Test1';
        emp2.Gender__c = 'M';
        emp2.Change_status__c = 'Pending';
        emp2.USER__c = userinfo.getuserid();
        insert emp2;
        
        Position_Employee__c posEmp2 = new Position_Employee__c();             
        posEmp2.Position__c = territory.id;
        posEmp2.Employee__c = emp2.id;        
        posEmp2.Status__c ='Approved';
        posEmp2.effective_start_date__c = date.today()-3;
        posEmp2.Effective_End_Date__c = date.today()+3;
        posEmp2.Assignment_Type__c = SalesIQGlobalConstants.POSITION_EMPLOYEE_ASSIGNMENT_SECONDARY;
        insert posEmp2;
        
                
        Team_Instance_Object_Attribute__c teamInstAttrImpactTab =  new Team_Instance_Object_Attribute__c();
        teamInstAttrImpactTab.Interface_Name__c = 'Impact ZIP Tab';
        teamInstAttrImpactTab.Attribute_API_Name__c = 'Team_Instance_Geography__r.Geography__r.Zip_Type__c';
        teamInstAttrImpactTab.Object_Name__c = 'Position_Geography__c';
        teamInstAttrImpactTab.Data_Type__c = 'Text';
        teamInstAttrImpactTab.Attribute_Display_Name__c = 'Label.GEO_Type';
        teamInstAttrImpactTab.isEnabled__c=true;
        teamInstAttrImpactTab.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttrImpactTab.Display_Column_Order__c = 1;
        insert teamInstAttrImpactTab;
        
        Team_Instance_Object_Attribute__c teamInstAttrAcInfo =  new Team_Instance_Object_Attribute__c();
        teamInstAttrAcInfo.Interface_Name__c = 'AccInfo';
        teamInstAttrAcInfo.Attribute_API_Name__c = 'Position__r.Name';
        teamInstAttrAcInfo.Object_Name__c = 'Position_Account__c';
        teamInstAttrAcInfo.Data_Type__c = 'Text';
        teamInstAttrAcInfo.Attribute_Display_Name__c = 'Position';
        teamInstAttrAcInfo.isEnabled__c=true;
        teamInstAttrAcInfo.Section__c='Assignment Information';
        teamInstAttrAcInfo.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttrAcInfo.Display_Column_Order__c = 2;
        insert teamInstAttrAcInfo;
        
        Team_Instance_Object_Attribute__c teamInstAttrZIPInfo =  new Team_Instance_Object_Attribute__c();
        teamInstAttrZIPInfo.Interface_Name__c = 'ZIPInfo';
        teamInstAttrZIPInfo.Attribute_API_Name__c = 'Position__r.Name';
        teamInstAttrZIPInfo.Object_Name__c = 'Position_Geography__c';
        teamInstAttrZIPInfo.Data_Type__c = 'Text';
        teamInstAttrZIPInfo.Section__c = 'Metrics';
        teamInstAttrZIPInfo.Attribute_Display_Name__c = 'Territory';
        teamInstAttrZIPInfo.isEnabled__c=true;
        teamInstAttrZIPInfo.Team_Instance__c = BaseTeamInstance.Id;
        teamInstAttrZIPInfo.Display_Column_Order__c = 1;
        insert teamInstAttrZIPInfo;   

        list<Team_Instance_Object_Attribute__c> allTeamAttrConfig  =new list<Team_Instance_Object_Attribute__c>();
        Team_Instance_Object_Attribute__c teamInstAttrStartDate =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ALIGNMENT_CONFIRMATION_POPUP_INTERFACE_NAME,'IC_EffstartDate__c','Team_Instance__c','Start Date',true,true,1);       
        //insert teamInstAttrStartDate;
        allTeamAttrConfig.add(teamInstAttrStartDate);
        
        
        Team_Instance_Object_Attribute__c teamInstAttrEndDate =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ALIGNMENT_CONFIRMATION_POPUP_INTERFACE_NAME,'IC_EffEndDate__c','Team_Instance__c','EndDate Date',true,true,2);       
        //insert teamInstAttrEndDate;
        allTeamAttrConfig.add(teamInstAttrEndDate);

        Team_Instance_Object_Attribute__c teamInstAttrAccountSortField =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, 'Map Account Sort Field','Metric2__c','Position_Account__c','Sales',true,true,1);       
        //insert teamInstAttrAccountSortField;
        allTeamAttrConfig.add(teamInstAttrAccountSortField);

        Team_Instance_Object_Attribute__c teamInstAttrPositionName =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.INTERFACE_NAME_POSITION_LIST_VIEW,'Name','Position__c','Position Name',true,true,1);       
        //insert teamInstAttrPositionName;
        allTeamAttrConfig.add(teamInstAttrPositionName);

        //Team_Instance_Object_Attribute__c teamInstAttrPositionCode =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.INTERFACE_NAME_POSITION_LIST_VIEW,'Client_Position_Code__c','Position__c','Position Code',true,true,1);       
        //insert teamInstAttrPositionCode;
        //allTeamAttrConfig.add(teamInstAttrPositionCode);

        Team_Instance_Object_Attribute__c teamInstAttrZIPPositionCode =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP,'Position__c','Position_Geography__c','Position Code',true,true,1);       
        //insert teamInstAttrZIPPositionCode;
        allTeamAttrConfig.add(teamInstAttrZIPPositionCode);

        Team_Instance_Object_Attribute__c teamInstAttrCreatePositionIsEditable =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP,'Client_Position_Code__c','Position__c','Position Code',true,true,1);       
        //insert teamInstAttrCreatePositionIsEditable;
        allTeamAttrConfig.add(teamInstAttrCreatePositionIsEditable);

        Team_Instance_Object_Attribute__c teamInstAttrCreatePositionIsReadable =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ROSTER_CREATE_POSITION_POPUP,'Name','Position__c','Position Name',true,false,2);       
        //insert teamInstAttrCreatePositionIsReadable;
        allTeamAttrConfig.add(teamInstAttrCreatePositionIsReadable);

        Team_Instance_Object_Attribute__c teamInstAttrImpactAccountTab =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ACCOUNT_IMPACT_TAB,'Team_Instance_Account__r.Account_ID__r.Name','Position_Account__c','Position Name',true,true,1);       
        //insert teamInstAttrImpactAccountTab;
        allTeamAttrConfig.add(teamInstAttrImpactAccountTab);

        Team_Instance_Object_Attribute__c teamInstAttrAccountRendring =  CallPlanTestDataFactory.createObjectAttributes(BaseTeamInstance, SalesIQGlobalConstants.ACCOUNT_RENDERING_INTERFACE_NAME,'Metric1__c','Position_Account__c','PAlignment Index',true,true,1);       
        //insert teamInstAttrAccountRendring;
        allTeamAttrConfig.add(teamInstAttrAccountRendring);
        
        insert allTeamAttrConfig;

        list<Team_Instance_Object_Attribute_Detail__c> attrDetails  = new list<Team_Instance_Object_Attribute_Detail__c>();
        Team_Instance_Object_Attribute_Detail__c accountRendringLowDetails = CallPlanTestDataFactory.createAttributesDetails(teamInstAttrAccountRendring, BaseTeamInstance, 'LOW','1');
        attrDetails.add(accountRendringLowDetails);

        Team_Instance_Object_Attribute_Detail__c accountRendringMediumDetails = CallPlanTestDataFactory.createAttributesDetails(teamInstAttrAccountRendring, BaseTeamInstance, 'MEDIUM','2');
        attrDetails.add(accountRendringMediumDetails);

        insert attrDetails;
        
        ETL_Config__c objETL = new ETL_Config__c();
        objETL.Name = SalesIQGlobalConstants.VALIDATE_CONTIGUITY_AND_DOUGHNUT;
        objETL.End_Point__c = 'https://gisdev.axtria.com/api/validateContiguityANDDoughnut?';
        insert objETL;





     //   map<String,list<Team_Instance_Object_Attribute_Detail__c>> renderattri = ScenarioAlignmentCtlr.getAccountRenderingAttributes(BaseTeamInstance.Id);
        //list<User_Access_Permission__c> lsUsers = ScenarioAlignmentCtlr.getTeamAndTeamInstances();
        
        
        
        CR_Approval_Config__c appConfig = new CR_Approval_Config__c(Team_Instance_ID__c = BaseTeamInstance.Id, Change_Request_Type__c = objRequest.Id, HO_Office_User__c = 'Y', HR_User__c = 'N', IsImpactedPosition__c = false, isHigherLevelManagers__c = false, isImpactedManager__c = true);
        insert appConfig;



        list<CR_Team_Instance_Config__c> allConfig = new list<CR_Team_Instance_Config__c>();
        CR_Team_Instance_Config__c objConfigZIP  =CallPlanTestDataFactory.LayerConfig('Level 0',SalesIQGlobalConstants.LAYER_CONFIG,'ZIP',true,BaseTeamInstance);
        allConfig.add(objConfigZIP);

        CR_Team_Instance_Config__c objConfigTerr  =CallPlanTestDataFactory.LayerConfig('Level 1',SalesIQGlobalConstants.LAYER_CONFIG,'Territory',false,BaseTeamInstance);
        allConfig.add(objConfigTerr);

        CR_Team_Instance_Config__c objConfigAccount  =CallPlanTestDataFactory.LayerConfig('Account',SalesIQGlobalConstants.LAYER_CONFIG,'Account',true,BaseTeamInstance);
        allConfig.add(objConfigAccount);

        CR_Team_Instance_Config__c objConfigHierarchyTerritory  =CallPlanTestDataFactory.LayerConfig('1',SalesIQGlobalConstants.HIERARCHY_CONFIG,'Territory',false,BaseTeamInstance);
        allConfig.add(objConfigHierarchyTerritory);

        CR_Team_Instance_Config__c objConfigHierarchyDistrict  =CallPlanTestDataFactory.LayerConfig('2',SalesIQGlobalConstants.HIERARCHY_CONFIG,'District',false,BaseTeamInstance);
        allConfig.add(objConfigHierarchyDistrict);

        CR_Team_Instance_Config__c objConfigNonFieldPosition  =CallPlanTestDataFactory.LayerConfig('Config Name','Non Field Position Type','Config Value',false,null);
        objConfigNonFieldPosition.create__c = true;
        objConfigNonFieldPosition.edit__c = true;
        objConfigNonFieldPosition.delete__c = false;
        allConfig.add(objConfigNonFieldPosition);

        insert allConfig;
            test.startTest();
            ScenarioAlignmentCtlr.enableOverlayImpactData(geo1.Name,acc1.AccountNumber,territory.Id,destTerr.Id,'ZIP','Current',System.Label.ZIP,BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.enableImpactData(geo1.Name,acc1.AccountNumber,territory.Id,destTerr.Id,'ZIP Movement','Hybrid',BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.enableImpactData(geo1.Name,acc1.AccountNumber,territory.Id,destTerr.Id,System.Label.ZIP,'ZIP',BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.checkValidationOnSubmit(BaseTeamInstance.Id,territory.Id,destTerr.Id,geo1.Name,acc1.AccountNumber,'Current','Account Movement');
            ScenarioAlignmentCtlr.getColorCriteria();
            ScenarioAlignmentCtlr.confirmSubmissionPending('11789','11780','11789','11780',territory.Id,destTerr.Id,'Current',BaseTeamInstance.Id);
            ScenarioAlignmentCtlr.deleteSubmissionPending(destTerr.Id,'Current');
            date dt = system.today();
            string  st=dt.format();
            ScenarioAlignmentCtlr.submitRequest(territory.Id,territory.Name,destTerr.Id,destTerr.Name,'11789,11780','11789,11780','',st,False,BaseTeamInstance.Id,'ZIP Movement','Account Realignment','','',False,True,country.Id,acc1.id,'Error');
           
            //ScenarioAlignmentCtlr.submitRequest(territory.Id,territory.Name,destTerr.Id,'11789,11780','11789,11780','',st,False,BaseTeamInstance.Id,'ZIP Movement','Account Realignment','','',False,True,country.Id, 'Error');
            test.stopTest();
    }
}